#!/bin/sh
# $Id: ips.sh,v 1.7 2013/09/17 17:46:40 ca Exp $
#
# Copyright (c) 2011 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.

# ---------------------------
# check local IP(v4) addresses
# ---------------------------

SD=`dirname $0`
[ X"$SD" = "X" ] && SD=.
. $SD/common.sh

NOLOCAL=false
GIOPTS=""
if test X"`uname`" != "XOSF1"
then
while getopts 46l FLAG
do
  case "${FLAG}" in
    4|6) GIOPTS="${GIOPTS} -$FLAG";;
    l) NOLOCAL=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

L=`$SD/getips.sh ${GIOPTS}`
if [ $? -ne 0 ]
then
  echo "$0: failed to get IP addresses"
  exit 1
fi

PORT=2525
SRV=../checks/t-net-0
#CLT=../statethreads/examples/clt2
CLT=${SRV}
if [ ! -x $SRV ]
then
  echo "$0: missing $SRV"
  exit 1
fi
if [ ! -x $CLT ]
then
  echo "$0: missing $CLT"
  exit 1
fi

CHARS=1

tryip()
{
  IP=$1

  CNT=0
  while [ ${CNT} -lt 3 ]
  do
    $CLT -c $CHARS -I $IP 2>/dev/null && return 0
    CNT=`expr ${CNT} + 1 `
    sleep 1
  done
  return 1
}

for ip in $L
do
  if $NOLOCAL
  then
    echo "$ip" | grep -w '127\.0\.0\.1' >/dev/null && continue
  fi
  $SRV -s $CHARS -I $ip >/dev/null 2>&1 &
  PID=$!
  if tryip $ip
  then
    printf "%s " "$ip"
  else
    kill $!
  fi
done
echo
