#!/bin/sh
# $Id: common.sh,v 1.6 2013/12/23 01:37:30 ca Exp $
#
# Copyright (c) 2013 Claus Assmann
#
# By using this file, you agree to the terms and conditions set
# forth in the license/LICENSE.3C file which can be found at the
# top level of this source code distribution.
#
test -s stop && exit 1

ERRS=0
OUT=mcp.out
PIDS=pids
BN=`basename $0 .sh`
CONF=restart.conf
PIDF1=${BN}-1.pid
PIDF2=${BN}-2.pid
PIDF3=${BN}-3.pid
L1=${L1:-${BN}-1.log}
L2=${L2:-${BN}-2.log}
L3=${L3:-${BN}-3.log}
R1=${BN}s1
R2=${BN}s2
R3=${BN}s3
VERBOSE=false
KEEP=false
PRG=./t-restart

test x"${SD}" = "x" && exit 1
. ${SD}/../check2/user.sh

if test X"`uname`" != "XOSF1"
then
while getopts KV FLAG
do
  case "${FLAG}" in
    K) KEEP=true;;
    V) VERBOSE=true;;
  esac
done
shift `expr ${OPTIND} - 1`
fi

cleanup()
{
rm -f ${PIDS} ${OUT} ${PIDF1} ${PIDF2} ${PIDF3} ${L1} ${L2} ${L3} ${R1} ${R2} ${R3}
}

cleanup

waitforfile()
{
 F=$1

 i=0
 while test ! -s ${F}
 do
   sleep 3
   i=`expr ${i} + 1 `
   if test ${i} -ge 4
   then
     echo "$0: ERROR: missing ${F}"
     ERRS=`expr ${ERRS} + 1 `
     return ${ERRS}
   fi
 done
 return 0
}

chkr()
{
  F=$1
  N=$2

  if grep "^$N$" $F >/dev/null
  then
    :
  else
    echo "$0: ERROR: missing $N in $F"
    ERRS=`expr ${ERRS} + 1 `
  fi
}

stopit()
{

test x"${PIDS}" = "x" && return 1
test -f ${PIDS} || return 0

for i in `cat ${PIDS}`
do
  kill ${i}
done
rm -f ${PIDS}
return 0
}

testend()
{
test ${ERRS} -eq 0 || exit ${ERRS}
$KEEP || cleanup
exit 0
}
