/*
 */

/*
**  Test s*printf() functions
*/

#include "sm/generic.h"
SM_RCSID("@(#)$Id: t-printf-0.c,v 1.1 2010/10/17 16:31:08 ca Exp $")

#include "sm/io.h"
#include "sm/str.h"

#define MAXL	128
#define STRL	16

static void
test(sm_file_T *fp, int reps)
{
	int l, i;
	sm_str_P str;
	time_t  start, elapsed;

	str = sm_str_new(NULL, STRL, MAXL);
	if (NULL == str) goto error;
	sm_str_clr(str);
	sm_str_scat(str, "S00000000001075E000");

	start = time((time_t *) 0);
	for (l = 0; l < reps; l++) {
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
		i = sm_io_fprintf(fp, "id=%T, ", str);
	}
	elapsed = time((time_t *) 0) - start;
	sm_io_fprintf(smioerr, "elapsed time: %ld\n", (long) elapsed);

	start = time((time_t *) 0);
	for (l = 0; l < reps; l++) {
		i = sm_io_fprintf(fp, "id=%T, id=%T, id=%T, id=%T, id=%T, id=%T, id=%T, id=%T, id=%T, id=%T, "
			, str, str, str, str, str, str, str, str, str, str);
	}
	elapsed = time((time_t *) 0) - start;
	sm_io_fprintf(smioerr, "elapsed time: %ld\n", (long) elapsed);

	sm_str_free(str);
	return;

  error:
	return;
}

int
main(int argc, char *argv[])
{
	int reps, c;

	reps = 1000;
	while ((c = getopt(argc, argv, "r:")) != -1) {
		switch (c) {
		  case 'r':
			reps = atoi(optarg);
			break;
		  default:
			return(1);
		}
	}
	test(smioout, reps);
	return 0;
}
